package com.supwisdom.institute.backend.common.framework.exception;

public class BaseException extends RuntimeException {

  /**
   * 
   */
  private static final long serialVersionUID = 2278568118369300446L;

  /**
   * 异常信息
   */
  protected String msg;

  /**
   * 具体异常码
   */
  protected int code = -1;

  public BaseException(int code, String msgFormat, Object... args) {
      super(String.format(msgFormat, args));
      this.code = code;
      this.msg = String.format(msgFormat, args);
  }

  public BaseException() {
      super();
  }

  public BaseException(String message, Throwable cause) {
      super(message, cause);
  }

  public BaseException(Throwable cause) {
      super(cause);
  }

  public BaseException(String message) {
      super(message);
  }

  public String getMsg() {
      return msg;
  }

  public int getCode() {
      return code;
  }

  /**
   * 实例化异常
   * 
   * @param msgFormat
   * @param args
   * @return
   */
  @Deprecated
  public BaseException newInstance(String msgFormat, Object... args) {
      return new BaseException(this.code, msgFormat, args);
  }
  
  public BaseException newInstance(int code, String msgFormat, Object... args) {
    return new BaseException(code, msgFormat, args);
  }

}
